/**
 * @file ConvertString.cpp
 * @date 2010/04/10 新規作成
 * @author
 *
 * ワイド文字列⇔マルチバイト文字列変換クラス
 */
#include <cstdlib>
#include "ConvertString.h"

/**
 * コンストラクタ
 */
ConvertString::ConvertString(){
	setlocale(LC_CTYPE, "");
}

/**
 * ワイド文字列からマルチバイト文字列
 * @param source 変換するワイド文字列
 * @return 変換されたマルチバイト文字列
 */
std::string ConvertString::convertToNarrow(const std::wstring &source) {
	 std::string destination;
	char *mbs = new char[source.length() * MB_CUR_MAX + 1];
	wcstombs(mbs, source.c_str(), source.length() * MB_CUR_MAX + 1);
	destination = mbs;
	delete [] mbs;
	return destination;
}

/**
 * マルチバイト文字列からワイド文字列
 * @param source 変換するマルチバイト文字列
 * @return 変換されたワイド文字列
 */
std::wstring ConvertString::convertToWide(const std::string &source) {
	std::wstring destination;
	wchar_t *wcs = new wchar_t[source.length() + 1];
	mbstowcs(wcs, source.c_str(), source.length() + 1);
	destination = wcs;
	delete [] wcs;
	return destination;
}
