/**
 * @file ManageThread.cpp
 * @date 2010/02/20 新規作成
 * @author
 *
 * Thread管理クラス
 */
#include <stdlib.h>
#include <sys/unistd.h>
#include "Define.h"
#include "ManageThread.h"

void *command_thread(void *argument){
	int return_value = EXIT_SUCCESS;
	TCommandThreadStruct *command = (TCommandThreadStruct*)argument;

	command->getData().isBegun = true;
	std::vector<std::string>::iterator iterator;
	int result = chdir(command->getData().commandDirectory.c_str());
	for(iterator = command->getData().commandString.begin();
			iterator != command->getData().commandString.end();
			iterator++){
		result = system(iterator->c_str());
	}
	command->getData().isEnded = true;
	pthread_exit(&return_value);
}

/**
 * コンストラクタ
 */
ManageThread::ManageThread(){
}

/**
 * デストラクタ
 */
ManageThread::~ManageThread(){
	/* メモリ開放 */
	if( (m_CommandThreadStruct.getData().isBegun == true) ||
	(m_CommandThreadStruct.getData().isEnded == true) ){
		m_ControlThread.waitForCompletion();
	}
}

/**
 * m_CommandThreadStructメンバの取得
 * @return m_CommandThreadStructメンバ
 */
TCommandThreadStruct& ManageThread::getData(){
	return m_CommandThreadStruct;
}

/**
 * m_ControlThreadメンバの取得
 * @return m_ControlThreadメンバ
 */
ControlThread& ManageThread::getControlThread(){
	return m_ControlThread;
}

/**
 * thread実行
 * @return 処理結果 OK/NG
 */
ReturnValue ManageThread::run(std::string path){
	/* メモリ開放 */
	if( (m_CommandThreadStruct.getData().isBegun == true) ||
			(m_CommandThreadStruct.getData().isEnded == true) ){
		m_ControlThread.waitForCompletion();
	}
	m_CommandThreadStruct.getData().commandDirectory = path;
	m_CommandThreadStruct.getData().isBegun = false;
	m_CommandThreadStruct.getData().isEnded = false;
	m_ControlThread.begin(command_thread, &m_CommandThreadStruct);
	return OK;
}
