/**
 * @file Test5.cpp
 * @date 2010/04/11 新規作成
 * @author
 *
 * Test5クラス
 */

#include <assert.h>
#include <iostream>
#include "Define.h"
#include "ParseLine.h"
#include "Test5.h"

/**
 * コンストラクタ
 */
Test5::Test5(){
}

/**
 * test関数
 */
ReturnValue Test5::run()
{
	test1();
	test2();
	test3();
	std::cout << "Test5 finished" << std::endl;
	return OK;
}

ReturnValue Test5::test1()
{
	ParseLine parse_line;
	assert(parse_line.parse("abcdefg") == INVALID);
	assert(parse_line.parse("[abcdefg") == INVALID);
	assert(parse_line.parse("abcdefg]") == INVALID);
	assert(parse_line.parse("[abc defg]") == INVALID);
	assert(parse_line.parse("[[abcdefg]") == INVALID);
	assert(parse_line.parse("[abcdefg]]") == INVALID);
	assert(parse_line.parse("[abc=defg]") == INVALID);
	assert(parse_line.parse("[  abcdefg  ]") == INVALID);
	assert(parse_line.parse("[abcdefg]") == SECTION);
	assert(parse_line.parse("[0123456]") == SECTION);
	return OK;
}

ReturnValue Test5::test2()
{
	ParseLine parse_line;
	assert(parse_line.parse("=abcdefg") == INVALID);
	assert(parse_line.parse(" abcdefg") == INVALID);
	assert(parse_line.parse("abcdefg ") == INVALID);
	assert(parse_line.parse("abcdefg = a 1") == PARAMETER);
	assert(parse_line.parse("abcdefg=") == PARAMETER);
	assert(parse_line.parse("     abcdefg=") == PARAMETER);
	assert(parse_line.parse("     abcdefg     =") == PARAMETER);
	assert(parse_line.parse("   abcdefg  = abcdefg") == PARAMETER);
	assert(parse_line.parse("   abcdefg  = abcdefg  ") == PARAMETER);
	assert(parse_line.parse("abcdefg= ;abcdefg") == PARAMETER);
	assert(parse_line.parse("abcdefg=abcdefg ;abcdefg") == PARAMETER);
	assert(parse_line.parse("abcdefg= #abcdefg") == PARAMETER);
	assert(parse_line.parse("abcdefg=abcdefg #abcdefg") == PARAMETER);
	return OK;
}

ReturnValue Test5::test3()
{
	ParseLine parse_line;
	assert(parse_line.parse("abcdefg ;abcdefg") == INVALID);
	assert(parse_line.parse("abcdefg #abcdefg") == INVALID);
	assert(parse_line.parse(";   abcdefg") == COMMENT);
	assert(parse_line.parse(";abcdefg") == COMMENT);
	assert(parse_line.parse("#abcdefg") == COMMENT);
	return OK;
}

