/**
 * @file Test7.cpp
 * @date 2010/04/17 新規作成
 * @author
 *
 * Test7クラス
 */

#include <assert.h>
#include <fstream>
#include <iostream>
#include <sstream>
#include <cstdio>
#include "Define.h"
#include "ManageThread.h"
#include "GetProfile.h"
#include "Test7.h"

/**
 * コンストラクタ
 */
Test7::Test7(){
}

/**
 * test関数
 */
ReturnValue Test7::run()
{
	test1();
	test2();
	test3();
	std::cout << "Test7 finished" << std::endl;
	return OK;
}

ReturnValue Test7::test1()
{
	ManageThread manage_thread;
	manage_thread.getData().getData().commandString.push_back("./fbvnc 1 2 3 4");
	manage_thread.run("./");
	manage_thread.getControlThread().waitForCompletion();
	return OK;
}

ReturnValue Test7::executeCommand(std::string file, std::string name)
{
	GetProfile get_profile(file);
	std::stringstream setting, command;
	ManageThread command_thread;
	setting << "setting_";
	setting << get_profile.getInt("display_number", "current");
	for(int i = 0; i < 5; i++){
		std::cout << name.c_str() << std::endl;
		command << name.c_str();
		command << std::dec << i + 1;
		std::cout << command.str().c_str() << std::endl;
		std::cout << get_profile.getString(setting.str(), command.str()).c_str() << std::endl;
		if( get_profile.getString(setting.str(), command.str()).size() != 0 ){
			command_thread.getData().getData().commandString.push_back(get_profile.getString(setting.str(), command.str()));
		}
		command.str("");
		command.clear(std::stringstream::goodbit);
	}
	command_thread.run("./");
	command_thread.getControlThread().waitForCompletion();
	return OK;
}

ReturnValue Test7::test2()
{
	executeCommand("3-1.ini", "pre_command_");
	std::cout << "pre_command end" << std::endl;
	executeCommand("3-1.ini", "post_command_");
	ManageThread fbvnc_thread;
	fbvnc_thread.getData().getData().commandString.push_back("./fbvnc -hw c700 -hideoverlays 192.168.1.1:0");
	fbvnc_thread.run("./");
	fbvnc_thread.getControlThread().waitForCompletion();
	return OK;
}

ReturnValue Test7::test3()
{
	GetProfile get_profile("3-2.ini");
	executeCommand("3-2.ini", "pre_command_");
	ManageThread fbvnc_thread;
	fbvnc_thread.getData().getData().commandString.push_back(get_profile.getString("setting_1", "fbvnc"));
	fbvnc_thread.run("./");
	fbvnc_thread.getControlThread().waitForCompletion();
	executeCommand("3-2.ini", "post_command_");
	return OK;
}

